{**************************************************************************}
{This sourcecode is part of the program mixer347. If you have any questions}
{or want to use or modify any part of it please email me (jacmet@iname.com)}
{**************************************************************************}
UNIT DB;
{ Unit that lets the programmer write debug information to a second        }
{ (hercules) screen. Can be changed for VGA if SCreenAddress is changed to }
{ 0B80000h.                                                                }
{ Created          : 10/05/98                                              }
{ Last modification: 16/05/98                                              }

INTERFACE

Type PosType    = record
                   X: 0..79;
                   Y: 0..24;
                  end;

var Attribute: byte;

Procedure WriteString(s: string);
Procedure WritelnString(s: string);
Procedure ClearScreen;
Procedure WriteDword(d: longint);
Procedure WriteWord(w: word);
Procedure WriteByte(b: byte);

IMPLEMENTATION

const ScreenAddress = $B0000;

type ScreenType = record
                   Character: char;
                   Attribute: byte;
                  end;

var Screen1: array[0..24,0..79] of ScreenType absolute ScreenAddress;
    Screen2: array[0..1999] of ScreenType absolute ScreenAddress;
    Position: PosType;

 Procedure Scroll(lines: byte);
  var a: longint;
  begin
   for a:=(lines*80) to 1999 do
    begin
     Screen2[a-(lines*80)].Character:=Screen2[a].Character;
     Screen2[a-(lines*80)].Attribute:=Screen2[a].Attribute;
    end;
   for a:=1999-(lines*80) to 1999 do
    begin
     Screen2[a].Character:=' ';
     Screen2[a].Attribute:=Attribute;
    end;
   Position.Y:=Position.Y-lines;
  end;

 Procedure ClearScreen;
  var a: longint;
  begin
   for a:=0 to 1999 do
    begin
     Screen2[a].Character:=' ';
     Screen2[a].Attribute:=Attribute;
    end;
   Position.Y:=0; Position.X:=0;
  end;

 Procedure WriteString(s: string);
  var a: longint;
  begin
   if Position.Y*80+Position.X+length(s)>1999 then
    begin
     Scroll((Position.Y*80+Position.X+length(s)-1920) div 80);
    end;

   for a:=(Position.Y*80+Position.X) to (Position.Y*80+Position.X+Length(s)-1) do
    begin
     Screen2[a].Character:=s[a+1-(Position.Y*80+Position.X)];
     Screen2[a].Attribute:=Attribute;
    end;
   Position.Y:=Position.Y+(Position.X+length(s)) div 80;
   Position.X:=(Position.X+length(s)) mod 80;
  end;

 Procedure WritelnString(s: string);
  var a: longint;
  begin
   if Position.Y*80+Position.X+length(s)>1919 then
    begin
     Scroll((Position.Y*80+Position.X+length(s)-1840) div 80);
    end;

   for a:=(Position.Y*80+Position.X) to (Position.Y*80+Position.X+Length(s)-1) do
    begin
     Screen2[a].Character:=s[a+1-(Position.Y*80+Position.X)];
     Screen2[a].Attribute:=Attribute;
    end;
   Position.Y:=(Position.Y+(Position.X+length(s)) div 80)+1;
   Position.X:=0;
  end;

 Procedure WriteDword(d: longint);
  const Hextable: array[0..15] of char = '0123456789ABCDEF';
  var a: byte;
      s: string;
  begin
   s:='0x';
   for a:=0 to 7 do
    begin
     s:=s+hextable[(d shr ((7-a)*4) and $F)];
    end;
    Writestring(s);
  end;

 Procedure WriteWord(w: word);
  const Hextable: array[0..15] of char = '0123456789ABCDEF';
  var a: byte;
      s: string;
  begin
   s:='0x';
   for a:=0 to 3 do
    begin
     s:=s+hextable[(w shr ((3-a)*4) and $F)];
    end;
    Writestring(s);
  end;

 Procedure WriteByte(b: byte);
  const Hextable: array[0..15] of char = '0123456789ABCDEF';
  var a: byte;
      s: string;
  begin
   s:='0x';
   for a:=0 to 1 do
    begin
     s:=s+hextable[(b shr ((1-a)*4) and $F)];
    end;
    Writestring(s);
  end;

begin
 Position.X:=0; Position.Y:=0; Attribute:=7;
 Clearscreen;
end.