{**************************************************************************}
{This sourcecode is part of the program mixer347. If you have any questions}
{or want to use or modify any part of it please email me (jacmet@iname.com)}
{**************************************************************************}
UNIT GUI;
{ Unit that does the Grapical User Interface.                              }
{ Created          : 19/05/98                                              }
{ Last modification: 22/05/98                                              }

INTERFACE
{==========================================================================}
Procedure Init;
{==========================================================================}
Procedure UpdateClippedLight(Clipped: boolean);
{==========================================================================}
Procedure UpdateVUs(VUpos1,VUpos2: byte);
{==========================================================================}
Procedure CheckKeys;
{==========================================================================}
Procedure DeInit;
{==========================================================================}

IMPLEMENTATION

USES VARIABLE,CRT,UTIL;

CONST value=0.02;

      DBtable: array[0..30] of double =
      (5.6234132519,5.01187233627,4.46683592151,3.98107170553,
      3.54813389234,3.16227766017,2.81838293126,2.51188643151,
      2.23872113857,1.99526231497,1.77827941004,1.58489319246,
      1.41253754462,1.25892541179,1.1220184543,1.0,0.891250938134,
      0.794328234724,0.707945784384,0.63095734448,0.56234132519,
      0.501187233627,0.446683592151,0.398107170553,0.354813389234,
      0.316227766017,0.281838293126,0.251188643151,0.223872113857,
      0.199526231497,0.177827941004);


VAR Gain_1,Gain_2: longint;
    low_1,low_2  : longint;
    mid_1,mid_2  : longint;
    high_1,high_2: longint;
    attack1time  : double;
    attack2time  : double;
    Release1time : double;
    Release2time : double;

{==========================================================================}
Procedure Update;
 begin
  textcolor(yellow);
  gotoxy(17,3); write(0-gain_1,' dB  '); gotoxy(67,3); write(0-gain_2,' dB  ');
  gotoxy(17,4); write(0-High_1,' dB  '); gotoxy(67,4); write(0-High_2,' dB  ');
  gotoxy(17,5); write(0-Mid_1,' dB  '); gotoxy(67,5); write(0-Mid_2,' dB  ');
  gotoxy(17,6); write(0-Low_1,' dB  '); gotoxy(67,6); write(0-Low_2,' dB  ');

  gotoxy(24,7); write(Gate1Threshold,'     '); gotoxy(74,7); write(Gate2Threshold,'     ');
  gotoxy(24,8); write(Gate1Hysterisis,'     '); gotoxy(74,8); write(Gate2Hysterisis,'     ');
  gotoxy(24,9); write(round(Gate1HoldTime/44.1),' ms  '); gotoxy(74,9); write(round(Gate2HoldTime/44.1),' ms  ');
  gotoxy(24,10); write(round(Release1Time*1000),' ms  '); gotoxy(74,10); write(round(Release2Time*1000),' ms  ');
  gotoxy(24,11); write(round(Attack1Time*1000),' ms  '); gotoxy(74,11); write(round(Attack2Time*1000),' ms  ');

  gotoxy(17,12); write(Volume1:2:2,'    '); gotoxy(67,12); write(Volume2:2:2,'    ');
  gotoxy(34,20); write(mastervolume:2:2,'   ');
  gotoxy(34,21); write((crossvolume*5):1:1,'   ');
 end;
{==========================================================================}
Procedure Init;
begin
 Hidecursor;
 textcolor(yellow);
 textbackground(blue);
 clrscr;
 Gotoxy(10,1); write('Kanal 1                 MIXER 347                 Kanal 2');
 Gotoxy(10,2); write('=======               =============               =======');
 gotoxy(5,3); write('GAIN (1/2):                                       GAIN (9/0):');
 gotoxy(5,4); write('HIGH (z/Z):                                       HIGH (m/M):');
 gotoxy(5,5); write('MID  (x/X):                                       MID  (n/N):');
 gotoxy(5,6); write('LOW  (c/C):                                       LOW  (b/B):');
 gotoxy(6,7); write('THRESHOLD  (q/Q):                                 THRESHOLD  (p/P):');
 gotoxy(6,8); write('HYSTERISIS (w/W):                                 HYSTERISIS (o/O):');
 gotoxy(6,9); write('HOLD       (e/E):                                 HOLD       (i/I):');
 gotoxy(6,10); write('RELEASE    (r/R):                                 RELEASE    (u/U):');
 gotoxy(6,11);write('ATTACK     (t/T):                                 ATTACK     (y/Y):');
 gotoxy(5,12);write('VOL  (3/4):                                       VOL  (7/8):');
 gotoxy(5,13);write('===========                                       ===========');
 gotoxy(5,14);write('VU-METER:                                         VU-METER:');
 gotoxy(32,15);write('CLIP:');
 gotoxy(20,20); write('MASTER (5/6):');
 gotoxy(20,21); write('CROSS  (g/h):');
 textcolor(red+blink);gotoxy(30,6);write('<ESC> TO QUIT!');
 Gain_1:=0; Gain_2:=0;
 Low_1:=0; Low_2:=0;
 Mid_1:=0; Mid_2:=0;
 High_1:=0; High_2:=0;
 If Gate1AttackSpeed>0.01 then Attack1time:=44100/Gate1AttackSpeed else Attack1Time:=1;
 If Gate2AttackSpeed>0.01 then Attack2time:=44100/Gate2AttackSpeed else Attack2Time:=1;
 If Gate1ReleaseSpeed>0.01 then Release1time:=44100/Gate1ReleaseSpeed else Release1Time:=1;
 If Gate2ReleaseSpeed>0.01 then Release2time:=44100/Gate2ReleaseSpeed else Release2Time:=1;

 update;
 end;
{==========================================================================}
Procedure UpdateClippedLight(Clipped: boolean);
 begin
  textcolor(yellow);
  gotoxy(40,15);
  textcolor(red);
  If clipped=true then
   begin
    Setpal(0,40,0,0);
    write('');
   end
  else
   begin
    Setpal(0,0,0,0);
    write('');
   end;
  textcolor(green);
 end;
{==========================================================================}
Procedure UpdateVUs(VUpos1,VUpos2: byte);
 var vu: dword;
 begin
  textcolor(green);
  gotoxy(5,17);
  for vu:=1 to 11 do
   begin
    if (vu shl 4)<VUpos1 then write('') else write('');
   end;
  textcolor(yellow);
  for vu:=12 to 14 do
   begin
    if (vu shl 4)<VUpos1 then write('') else write('');
   end;
  textcolor(red);
  for vu:=15 to 16 do
   begin
    if ((vu shl 4)-1)<=VUpos1 then write('') else write('');
   end;
  textcolor(green);

  gotoxy(55,17);
  for vu:=1 to 11 do
   begin
    if (vu shl 4)<VUpos2 then write('') else write('');
   end;
  textcolor(yellow);
  for vu:=12 to 14 do
   begin
    if (vu shl 4)<VUpos2 then write('') else write('');
   end;
  textcolor(red);
  for vu:=15 to 16 do
   begin
    if ((vu shl 4)-1)<=VUpos2 then write('') else write('');
   end;
 end;
{==========================================================================}
Procedure CheckKeys;
 var c: char;
 begin
  if keypressed then
   begin
    c:=readkey;
    case c of
    'Z': begin
          High_1:=High_1-1;
          if High_1<-15 then High_1:=-15;
          A1Highpass:=dBTable[High_1+15];
          RecalcImpulse1:=True;
         end;
    'z': begin
          High_1:=High_1+1;
          if High_1>15 then High_1:=15;
          A1Highpass:=dBTable[High_1+15];
          RecalcImpulse1:=True;
         end;
    'X': begin
          Mid_1:=Mid_1-1;
          if Mid_1<-15 then Mid_1:=-15;
          A1bandpass:=dBTable[Mid_1+15];
          RecalcImpulse1:=True;
         end;
    'x': begin
          Mid_1:=Mid_1+1;
          if Mid_1>15 then Mid_1:=15;
          A1bandpass:=dBTable[Mid_1+15];
          RecalcImpulse1:=True;
         end;
    'C': begin
          Low_1:=Low_1-1;
          if Low_1<-15 then Low_1:=-15;
          A1lowpass:=dBTable[Mid_1+15];
          RecalcImpulse1:=True;
         end;
    'c': begin
          Low_1:=Low_1+1;
          if Low_1>15 then Low_1:=15;
          A1lowpass:=dBTable[Mid_1+15];
          RecalcImpulse1:=True;
         end;
    '4': begin
          Volume1:=Volume1+value;
          if Volume1>3.16227766 then Volume1:=3.16227766;
         end;
    '3': begin
          Volume1:=Volume1-value;
          if Volume1<0 then Volume1:=0.0;
         end;
    '2': begin
          gain_1:=gain_1-1;
          if gain_1<-15 then Gain_1:=-15;
          GAIN1:=dBTable[gain_1+15];
          RecalcImpulse1:=True;
         end;
    '1': begin
          gain_1:=gain_1+1;
          if gain_1>15 then Gain_1:=15;
          GAIN1:=dBTable[gain_1+15];
          RecalcImpulse1:=True;
         end;
    '5': begin
          MasterVolume:=Mastervolume-value;
          if mastervolume<0 then mastervolume:=0;
         end;
    '6': begin
          MasterVolume:=Mastervolume+value;
          if mastervolume>3.16227766 then mastervolume:=3.16227766;
         end;
    'M': begin
          High_2:=High_2-1;
          if High_2<-15 then High_2:=-15;
          A2Highpass:=dBTable[High_2+15];
          RecalcImpulse2:=True;
         end;
    'm': begin
          High_2:=High_2+1;
          if High_2>15 then High_2:=15;
          A2Highpass:=dBTable[High_2+15];
          RecalcImpulse2:=True;
         end;
    'N': begin
          Mid_2:=Mid_2-1;
          if Mid_2<-15 then Mid_2:=-15;
          A2bandpass:=dBTable[Mid_2+15];
          RecalcImpulse2:=True;
         end;
    'n': begin
          Mid_2:=Mid_2+1;
          if Mid_2>15 then Mid_2:=15;
          A2bandpass:=dBTable[Mid_2+15];
          RecalcImpulse2:=True;
         end;
    'B': begin
          Low_2:=Low_2-1;
          if Low_2<-15 then Low_2:=-15;
          A2lowpass:=dBTable[Mid_2+15];
          RecalcImpulse2:=True;
         end;
    'b': begin
          Low_2:=Low_2+1;
          if Low_2>15 then Low_2:=15;
          A2lowpass:=dBTable[Mid_2+15];
          RecalcImpulse2:=True;
         end;
    '8': begin
          Volume2:=Volume2+value;
          if Volume2>3.16227766 then Volume2:=3.16227766;
         end;
    '7': begin
          Volume2:=Volume2-value;
          if Volume2<0 then Volume2:=0.0;
         end;
    '0': begin
          gain_2:=gain_2-1;
          if gain_2<-15 then Gain_2:=-15;
          GAIN2:=dBTable[gain_2+15];
          RecalcImpulse2:=True;
         end;
    '9': begin
          gain_2:=gain_2+1;
          if gain_2>15 then Gain_2:=15;
          GAIN2:=dBTable[gain_2+15];
          RecalcImpulse2:=True;
         end;
    'Q': begin
          Gate1Threshold:=Gate1Threshold+512;
          if Gate1Threshold>184268 then Gate1Threshold:=184268;
         end;
    'q': begin
          Gate1Threshold:=Gate1Threshold-512;
          if Gate1Threshold<0 then Gate1Threshold:=0;
         end;
    'W': begin
          Gate1Hysterisis:=Gate1Hysterisis+64;
          if Gate1Hysterisis>8192 then Gate1Hysterisis:=8192;
         end;
    'w': begin
          Gate1Hysterisis:=Gate1Hysterisis-64;
          if Gate1Hysterisis<0 then Gate1Hysterisis:=0;
         end;
    'E': begin
          Gate1HoldTime:=Gate1HoldTime+512;
          if Gate1HoldTime>88200 then Gate1HoldTime:=88200;
         end;
    'e': begin
          Gate1HoldTime:=Gate1HoldTime-512;
          if Gate1HoldTime<2206 then Gate1HoldTime:=2206; {fmin=20Hz => 2205}
         end;
    'R': begin
          Release1Time:=Release1Time+0.05;
          if Release1Time>2 then Release1Time:=2;
          if Release1Time>0.01 then Gate1ReleaseSpeed:=1/(44100*Release1Time)
                           else Gate1ReleaseSpeed:=1;
         end;
    'r': begin
          Release1Time:=Release1Time-0.05;
          if Release1Time<0 then Release1Time:=0;
          if Release1Time>0.01 then Gate1ReleaseSpeed:=1/(44100*Release1Time)
                           else Gate1ReleaseSpeed:=1;
         end;
    'T': begin
          Attack1Time:=Attack1Time+0.05;
          if Attack1Time>2 then Attack1Time:=2;
          if Attack1Time>0.01 then Gate1AttackSpeed:=1/(44100*Attack1Time)
                           else Gate1AttackSpeed:=1;
         end;
    't': begin
          Attack1Time:=Attack1Time-0.05;
          if Attack1Time<0 then Attack1Time:=0;
          if Attack1Time>0.01 then Gate1AttackSpeed:=1/(44100*Attack1Time)
                           else Gate1AttackSpeed:=1;
         end;
    'P': begin
          Gate2Threshold:=Gate2Threshold+512;
          if Gate2Threshold>184268 then Gate2Threshold:=184268;
         end;
    'p': begin
          Gate2Threshold:=Gate2Threshold-512;
          if Gate2Threshold<0 then Gate2Threshold:=0;
         end;
    'O': begin
          Gate2Hysterisis:=Gate2Hysterisis+64;
          if Gate2Hysterisis>8192 then Gate2Hysterisis:=8192;
         end;
    'o': begin
          Gate2Hysterisis:=Gate2Hysterisis-64;
          if Gate2Hysterisis<0 then Gate2Hysterisis:=0;
         end;
    'I': begin
          Gate2HoldTime:=Gate2HoldTime+512;
          if Gate2HoldTime>88200 then Gate2HoldTime:=88200;
         end;
    'i': begin
          Gate2HoldTime:=Gate2HoldTime-512;
          if Gate2HoldTime<2206 then Gate2HoldTime:=2206; {fmin=20Hz => Tmin=2205}
         end;
    'U': begin
          Release2Time:=Release2Time+0.05;
          if Release2Time>2 then Release2Time:=2;
          if Release2Time>0.01 then Gate2ReleaseSpeed:=1/(44100*Release2Time)
                           else Gate2ReleaseSpeed:=1;
         end;
    'u': begin
          Release2Time:=Release2Time-0.05;
          if Release2Time<0 then Release2Time:=0;
          if Release2Time>0.01 then Gate2ReleaseSpeed:=1/(44100*Release2Time)
                           else Gate2ReleaseSpeed:=1;
         end;
    'Y': begin
          Attack2Time:=Attack2Time+0.05;
          if Attack2Time>2 then Attack2Time:=2;
          if Attack2Time>0.01 then Gate2AttackSpeed:=1/(44100*Attack2Time)
                           else Gate2AttackSpeed:=1;
         end;
    'y': begin
          Attack2Time:=Attack2Time-0.05;
          if Attack2Time<0 then Attack2Time:=0;
          if Attack2Time>0.01 then Gate2AttackSpeed:=1/(44100*Attack2Time)
                           else Gate2AttackSpeed:=1;
         end;
    'g': begin
          CrossVolume:=Crossvolume-value;
          if Crossvolume<0 then Crossvolume:=0;
         end;
    'h': begin
          CrossVolume:=Crossvolume+value;
          if Crossvolume>2 then Crossvolume:=2;
         end;
    #27: StopProgram:=True;
    end;
   GUI.Update;
   end;
 end;
{==========================================================================}
Procedure DeInit;
 begin
  setpal(0,0,0,0);
  textcolor(lightgray);
  textbackground(black);
  clrscr;
 end;
{==========================================================================}

Begin
end.
