{**************************************************************************}
{This sourcecode is part of the program mixer347. If you have any questions}
{or want to use or modify any part of it please email me (jacmet@iname.com)}
{**************************************************************************}
UNIT VARIABLE;
{ Unit that defines global variables.                                      }
{ Created          : 10/05/98                                              }
{ Last modification: 25/05/98                                              }

INTERFACE

CONST
     BufferSize = 1024; {strrelsen p bufferen, skal vre (2^n)}
     FirOrder = 100;
     KoefficientFilename = 'MIX347.DAT';
     PictureFileName = 'MIX347.PCX';
VAR
    {soundcard}
    BaseAddress : dword;
    DMA8,DMA16  : byte;
    IRQ         : byte;
    OldVector   : FarPointer;
    InputBuffer : ^array[0..(2*BufferSize-1),1..2] of integer;
    OutputBuffer: ^array[0..(2*BufferSize-1)] of byte;
    InputPosition,OldInputposition,
    OutputPosition,OldOutputPosition: longint;
    {EQ}
    X1,X2: array[0..(2*BufferSize-1)] of double;
    Y1,Y2: array[0..(BufferSize-1)] of double;
    A1lowpass,A1bandpass,A1highpass,
    A2lowpass,A2bandpass,A2highpass: double;
    Hlowpass,Hbandpass,Hhighpass,H1,H2: array[0..FirOrder] of double;
    {gate}
    Gate1Threshold: longint;  {amplitude-limit for fade-out}
    Gate1Hysterisis: longint; {amplitude-limit for fade-in}
    Gate1HoldTime: longint;   {tid/antal samples, der skal ventes, inden fade-out begyndes}
    Gate1HoldCount: longint;  {begynder at tlle op, nr "threshold" er net}
    Gate1ReleaseSpeed: double;{Gate_Amp ndring pr. sample under fade out}
    Gate1AttackSpeed: double; {Gate_Amp ndring pr. sample under fade-in}
    Gate1Amp: double;         {GateOutput = GateInput*Gate_Amp}

    Gate2Threshold: longint;  {amplitude-grnse for fade-out}
    Gate2Hysterisis: longint; {amplitude-grnse for fade-in}
    Gate2HoldTime: longint;   {tid/antal samples, der skal ventes, inden fade-out begyndes}
    Gate2HoldCount: longint;  {begynder at tlle op, nr "threshold" er net}
    Gate2ReleaseSpeed: double;{Gate_Amp ndring pr. sample under fade out}
    Gate2AttackSpeed: double; {Gate_Amp ndring pr. sample under fade-in}
    Gate2Amp: double;         {GateOutput = GateInput*Gate_Amp}
    {div}
    OldExitprocedure: pointer;
    StopProgram: boolean;
    ReCalcImpulse1,ReCalcImpulse2: boolean;
    DoRasmusRadiomus1,DoRasmusRadiomus2: boolean;
    Volume1,Volume2: double;
    Gain1,Gain2: double;
    CrossVolume: double;
    MasterVolume: double;

IMPLEMENTATION

BEGIN
END.
