{**************************************************************************}
{This sourcecode is part of the program mixer347. If you have any questions}
{or want to use or modify any part of it please email me (jacmet@iname.com)}
{**************************************************************************}
UNIT GUI2;
{ Unit that does the Grapical User Interface.                              }
{ Created          : 23/05/98                                              }
{ Last modification: 25/05/98                                              }

INTERFACE

{==========================================================================}
Procedure Init;
{ initializes GUI.                                                         }
Procedure DeInit;
{ deinitializes GUI.                                                       }
procedure UpdateVUs(VUpos1,VUpos2: byte);
{ updates VUs.                                                             }
Procedure UpdateClippedLight(Clipped: boolean);
{ Updates the clip indicator.                                              }
{==========================================================================}

IMPLEMENTATION

uses Mouse,Util,Variable,Mixer{,db};

const PowerX  = 265; PowerY = 176;
      CrossX  = 127; CrossY = 146;
      MasterX = 127; MasterY = 171;
      ClipX   = 151; ClipY = 122;
      {channel 1}
      Mic1X   = 40;  Mic1Y   = 18;
      Line1LX = 60;  Line1LY = 18;
      Line1RX = 60;  Line1RY = 26;
      CD1LX   = 80;  CD1LY   = 18;
      CD1RX   = 80;  CD1RY   = 26;
      Rasmus1X =40;  Rasmus1Y=106;
      Vol1X   = 114; Vol1Y   = 51;
      Gain1X  = 41;  Gain1Y  = 36;
      Low1X   = 44;  Low1Y   = 58;
      Mid1X   = 62;  Mid1Y   = 58;
      High1X  = 80;  High1Y  = 58;
      Thres1X  = 30;  Thres1Y  = 130;
      Hys1X   = 48;  Hys1Y   = 130;
      Hold1X  = 66;  Hold1Y  = 130;
      Rel1X   = 84;  Rel1Y   = 130;
      Atck1X  = 102; Atck1Y  = 130;
      {channel 2}
      Mic2X   = 222; Mic2Y   = 18;
      Line2LX = 242; Line2LY = 18;
      Line2RX = 242; Line2RY = 26;
      CD2LX   = 262; CD2LY   = 18;
      CD2RX   = 262; CD2RY   = 26;
      Rasmus2X =222; Rasmus2Y=106;
      Vol2X   = 191; Vol2Y   = 51;
      Gain2X  = 244; Gain2Y  = 36;
      Low2X   = 222; Low2Y   = 58;
      Mid2X   = 240; Mid2Y   = 58;
      High2X  = 258; High2Y  = 58;
      Thres2X  = 201; Thres2Y  = 130;
      Hys2X   = 219; Hys2Y   = 130;
      Hold2X  = 237; Hold2Y  = 130;
      Rel2X   = 255; Rel2Y   = 130;
      Atck2X  = 273; Atck2Y  = 130;

      DBtable: array[0..30] of double =
      (5.6234132519,5.01187233627,4.46683592151,3.98107170553,
      3.54813389234,3.16227766017,2.81838293126,2.51188643151,
      2.23872113857,1.99526231497,1.77827941004,1.58489319246,
      1.41253754462,1.25892541179,1.1220184543,1.0,0.891250938134,
      0.794328234724,0.707945784384,0.63095734448,0.56234132519,
      0.501187233627,0.446683592151,0.398107170553,0.354813389234,
      0.316227766017,0.281838293126,0.251188643151,0.223872113857,
      0.199526231497,0.177827941004);

var {generel variables}
    screen1: array[0..63999] of byte absolute $A0000;
    screen2: array[0..199,0..319] of byte absolute $A0000;
    screen3: array[0..15999] of dword absolute $A0000;
    {Mouse handling variables}
    Callstructure: array[0..199,0..319] of ^procedure;
    LastMousePosition : dword;
    MouseANDmask : array[0..63] of dword;
    MouseORmask  : array[0..63] of dword;
    MouseANDmask2: array[0..255] of byte absolute MouseANDmask;
    MouseORmask2 : array[0..255] of byte absolute MouseORmask;
    Background   : array[0..63] of dword;
    Background2  : array[0..255] of byte absolute background;
    MouseX,MouseY: longint;
    Buttonspressed: byte;
    Callmask     : byte;
    {graphics related variables}
    Button_on : array[0..143] of byte;
    Button_off: array[0..143] of byte;
    Mixer1_but: array[0..54] of byte;
    Mixer2_but: array[0..54] of byte;
    Cross_bck : array[0..54] of byte;
    Master_bck: array[0..54] of byte;
    Vol1_bck  : array[0..54] of byte;
    Gain1_bck : array[0..54] of byte;
    Low1_bck  : array[0..54] of byte;
    Mid1_bck  : array[0..54] of byte;
    High1_bck : array[0..54] of byte;
    Thres1_bck: array[0..54] of byte;
    Hys1_bck  : array[0..54] of byte;
    Hold1_bck : array[0..54] of byte;
    Rel1_bck  : array[0..54] of byte;
    Atck1_bck : array[0..54] of byte;
    Vol2_bck  : array[0..54] of byte;
    Gain2_bck : array[0..54] of byte;
    Low2_bck  : array[0..54] of byte;
    Mid2_bck  : array[0..54] of byte;
    High2_bck : array[0..54] of byte;
    Thres2_bck: array[0..54] of byte;
    Hys2_bck  : array[0..54] of byte;
    Hold2_bck : array[0..54] of byte;
    Rel2_bck  : array[0..54] of byte;
    Atck2_bck : array[0..54] of byte;
    Clip_on   : array[0..63] of dword;
    Clip_off  : array[0..63] of dword;

    LastCrossPosition : dword;
    LastMasterPosition: dword;

    LastVol1Position  : dword;
    LastGain1Position : dword;
    LastLow1position  : dword;
    LastMid1position  : dword;
    LastHigh1position : dword;
    LastThres1Position : dword;
    LastHys1Position  : dword;
    LastHold1Position : dword;
    LastRel1Position  : dword;
    LastAtck1Position : dword;

    LastVol2Position  : dword;
    LastGain2Position : dword;
    LastLow2position  : dword;
    LastMid2position  : dword;
    LastHigh2position : dword;
    LastThres2Position : dword;
    LastHys2Position  : dword;
    LastHold2Position : dword;
    LastRel2Position  : dword;
    LastAtck2Position : dword;
    Active : byte;

    {buttons}
    Mic1value              : boolean;
    Line1Lvalue,Line1Rvalue: boolean;
    CD1Lvalue,CD1Rvalue    : boolean;
    Mic2value              : boolean;
    Line2Lvalue,Line2Rvalue: boolean;
    CD2Lvalue,CD2Rvalue    : boolean;

{======================================================}
Procedure DefineRange(Xmin,Xmax,Ymin,Ymax:dword);
{Defines cursor range. This means that the mouse can only be moved      }
{around inside the square defined by Xmin,Ymin - Xmax,Ymax.             }
 begin
  asm
   mov eax, 07h                     {Define horizontal range.           }
   mov ecx, [Xmin]
   mov edx, [Xmax]
   shl ecx, 1
   shl edx, 1
   int 33h

   inc eax                          {Define vertical range.             }
   mov ecx, [Ymin]
   mov edx, [Ymax]
   int 33h
  end;
 end;                               {DefineRange                        }
{=======================================================================}
Procedure Readgraphics(filename: string);
 type Tpcx_format = record
                     Manufacturer: byte;
                     Version     : byte;
                     Encoding    : byte;
                     Bpp         : byte;
                     Xmin,Ymin   : word;
                     Xmax,Ymax   : word;
                     Hres,Vres   : word;
                     Colormap    : array[1..48] of byte;
                     Reserved    : byte;
                     Colorplanes : byte;
                     Bpl         : word;
                     Color       : word;
                     Filler      : array[1..58] of byte;
                     {data}
                     Data        : array[0..100000] of byte;
		    end;
 var f: file;
     buffer: ^Tpcx_format;
     unpacked1: ^array[0..69199] of byte;
     unpacked2: ^array[0..17279] of dword;
     n,m,l,numberofpixels: longint;
     pixel: byte;
 begin
  if not(fileexist(filename)) then
   begin
    setmode(TEXT);
    writeln('ERROR! file '+filename+' not found!');
    writeln('Halting..');
    halt;
   end;
  assign(f,filename);
  SYSTEM.Reset(f,1);
  getmem(buffer,filesize(f));
  blockread(f,buffer^,filesize(f));
  SYSTEM.Close(f);
  numberofpixels:=(buffer^.Xmax-buffer^.Xmin+1)
                  *(buffer^.Ymax-buffer^.Ymin+1);
  getmem(unpacked1,numberofpixels);
  dword(unpacked2):=dword(unpacked1);
  n:=0; m:=0;
  repeat
   if (buffer^.data[n] and 192)<>0 then
    begin
     pixel:=buffer^.data[n+1];
     if (buffer^.data[n] and 63)>0 then
      for m:=m to (m+(buffer^.data[n] and 63)) do unpacked1^[m]:=pixel
     else
      begin
       unpacked1^[m+1]:=buffer^.data[n+1];
      end;
     n:=n+2;
    end
   else
    begin
     unpacked1^[m]:=buffer^.data[n];
     inc(n);
     inc(m);
    end;
  until m=numberofpixels;
  n:=n+1;
  for m:=0 to 255 do
   begin
    UTIL.Setpal(m,buffer^.data[n] shr 2,buffer^.data[n+1] shr 2,buffer^.data[n+2] shr 2);
    n:=n+3;
   end;
  freemem(buffer,filesize(f));
  {fill screen}
  for n:=0 to 15999 do screen3[n]:=unpacked2^[n];
  {fill buffers}
  n:=16000;
  m:=-1;
  repeat
   for m:=(m+1) to (m+4) do
    begin
     MouseORmask[m]:=unpacked2^[n+m];
    end;
   n:=n+76;
  until m=63;
  n:=64016;
  m:=-1;
  repeat
   for m:=(m+1) to (m+16) do
    begin
     button_off[m]:=unpacked1^[n+m];
    end;
   n:=n+304;
  until m=143;
  n:=64032;
  m:=-1;
  repeat
   for m:=(m+1) to (m+16) do
    begin
     button_on[m]:=unpacked1^[n+m];
    end;
   n:=n+304;
  until m=143;
  n:=64048;
  m:=-1;
  repeat
   for m:=(m+1) to (m+11) do
    begin
     Mixer1_But[m]:=unpacked1^[n+m];
    end;
   n:=n+309;
  until m=54;
  n:=64064;
  m:=-1;
  repeat
   for m:=(m+1) to (m+5) do
    begin
     Mixer2_But[m]:=unpacked1^[n+m];
    end;
   n:=n+315;
  until m=54;
  n:=16020;
  m:=-1;
  repeat
   for m:=(m+1) to (m+4) do
    begin
     Clip_on[m]:=unpacked2^[n+m];
    end;
   n:=n+76;
  until m=63;
  n:=16024;
  m:=-1;
  repeat
   for m:=(m+1) to (m+4) do
    begin
     Clip_off[m]:=unpacked2^[n+m];
    end;
   n:=n+76;
  until m=63;
  {make MouseANDmask}
  for m:=0 to 255 do
  begin
   if MouseORmask2[m]>0 then MouseANDmask2[m]:=0 else MouseANDmask2[m]:=$FF;
  end;
  {deallocate unpacked}
  freemem(unpacked1,numberofpixels);
 end;
{======================================================}
Procedure foo;
 begin
 end;
{======================================================}
Procedure saveMixerbackground1(startpos: dword; where:^array[0..54] of byte);
 var c1,c2: longint;
     source:^array[0..54] of byte;
 begin
  dword(source):=$A0000+startpos;
  c1:=-1;
  c2:=0;

  repeat
   for c1:=(c1+1) to (c1+11) do where^[c1]:=source^[c1+c2];
   c2:=c2+309;
  until c1=54;
 end;
{======================================================}
Procedure RestoreMixerbackground1(startpos: dword; where:^array[0..54] of byte);
 var c1,c2: longint;
     dest:^array[0..54] of byte;
 begin
  dword(dest):=$A0000+startpos;
  c2:=0;
  c1:=-1;

  repeat
   for c1:=(c1+1) to (c1+11) do dest^[c1+c2]:=where^[c1];
   c2:=c2+309;
  until c1=54;
 end;
{======================================================}
Procedure DrawMixer1(startpos: dword);
 var c1,c2: longint;
     s:^array[0..54] of byte;
 begin
  dword(s):=$A0000+startpos;
  c1:=-1;
  c2:=0;

  repeat
   for c1:=(c1+1) to (c1+11) do s^[c1+c2]:=Mixer1_But[c1];
   c2:=c2+309;
  until c1=54;
 end;
{======================================================}
Procedure saveMixerbackground2(startpos: dword; where:^array[0..54] of byte);
 var c1,c2: longint;
     source:^array[0..54] of byte;
 begin
  dword(source):=$A0000+startpos;
  c1:=-1;
  c2:=0;

  repeat
   for c1:=(c1+1) to (c1+5) do where^[c1]:=source^[c1+c2];
   c2:=c2+315;
  until c1=54;
 end;
{======================================================}
Procedure RestoreMixerbackground2(startpos: dword; where:^array[0..54] of byte);
 var c1,c2: longint;
     dest:^array[0..54] of byte;
 begin
  dword(dest):=$A0000+startpos;
  c2:=0;
  c1:=-1;

  repeat
   for c1:=(c1+1) to (c1+5) do dest^[c1+c2]:=where^[c1];
   c2:=c2+315;
  until c1=54;
 end;
{======================================================}
Procedure DrawMixer2(startpos: dword);
 var c1,c2: longint;
     s:^array[0..54] of byte;
 begin
  dword(s):=$A0000+startpos;
  c1:=-1;
  c2:=0;

  repeat
   for c1:=(c1+1) to (c1+5) do s^[c1+c2]:=Mixer2_But[c1];
   c2:=c2+315;
  until c1=54;
 end;
{======================================================}
procedure Power;
 begin
  if (callmask and 2)=2 then
   begin
    StopProgram:=True;
   end;
 end;
{======================================================}
procedure Mic1;
 var a,b: dword;
 begin
  if (callmask and 2)=2 then
   begin
    Mic1value:=not(Mic1value);
    if Mic1value=true then
     begin
      for a:=0 to 8 do
       begin
        for b:=0 to 15 do screen2[Mic1Y+a,Mic1X+b]:=Button_on[(a shl 4)+b];
       end;
     end
    else
     begin
      for a:=0 to 8 do
       begin
        for b:=0 to 15 do screen2[Mic1Y+a,Mic1X+b]:=Button_off[(a shl 4)+b];
       end;
     end;
    MIXER.Set_Input_Control_Left(Mic1Value,CD1RValue,CD1LValue,
          Line1RValue,Line1LValue,false,false);
   end;
 end;
{======================================================}
procedure Line1L;
 var a,b: dword;
 begin
  if (callmask and 2)=2 then
   begin
    Line1Lvalue:=not(Line1Lvalue);
    if Line1Lvalue=true then
     begin
      for a:=0 to 8 do
       begin
        for b:=0 to 15 do screen2[Line1LY+a,Line1LX+b]:=Button_on[(a shl 4)+b];
       end;
     end
    else
     begin
      for a:=0 to 8 do
       begin
        for b:=0 to 15 do screen2[Line1LY+a,Line1LX+b]:=Button_off[(a shl 4)+b];
       end;
     end;
    MIXER.Set_Input_Control_Left(Mic1Value,CD1RValue,CD1LValue,
          Line1RValue,Line1LValue,false,false);
   end;
 end;
{======================================================}
procedure Line1R;
 var a,b: dword;
 begin
  if (callmask and 2)=2 then
   begin
    Line1rvalue:=not(Line1Rvalue);
    if Line1Rvalue=true then
     begin
      for a:=0 to 8 do
       begin
        for b:=0 to 15 do screen2[Line1RY+a,Line1RX+b]:=Button_on[(a shl 4)+b];
       end;
     end
    else
     begin
      for a:=0 to 8 do
       begin
        for b:=0 to 15 do screen2[Line1RY+a,Line1RX+b]:=Button_off[(a shl 4)+b];
       end;
     end;
    MIXER.Set_Input_Control_Left(Mic1Value,CD1RValue,CD1LValue,
          Line1RValue,Line1LValue,false,false);
   end;
 end;
{======================================================}
procedure CD1L;
 var a,b: dword;
 begin
  if (callmask and 2)=2 then
   begin
    CD1Lvalue:=not(CD1Lvalue);
    if CD1Lvalue=true then
     begin
      for a:=0 to 8 do
       begin
        for b:=0 to 15 do screen2[CD1LY+a,CD1LX+b]:=Button_on[(a shl 4)+b];
       end;
     end
    else
     begin
      for a:=0 to 8 do
       begin
        for b:=0 to 15 do screen2[CD1LY+a,CD1LX+b]:=Button_off[(a shl 4)+b];
       end;
     end;
    MIXER.Set_Input_Control_Left(Mic1Value,CD1RValue,CD1LValue,
          Line1RValue,Line1LValue,false,false);
   end;
 end;
{======================================================}
procedure CD1R;
 var a,b: dword;
 begin
  if (callmask and 2)=2 then
   begin
    CD1rvalue:=not(CD1Rvalue);
    if CD1Rvalue=true then
     begin
      for a:=0 to 8 do
       begin
        for b:=0 to 15 do screen2[CD1RY+a,CD1RX+b]:=Button_on[(a shl 4)+b];
       end;
     end
    else
     begin
      for a:=0 to 8 do
       begin
        for b:=0 to 15 do screen2[CD1RY+a,CD1RX+b]:=Button_off[(a shl 4)+b];
       end;
     end;
    MIXER.Set_Input_Control_Left(Mic1Value,CD1RValue,CD1LValue,
          Line1RValue,Line1LValue,false,false);
   end;
 end;
{======================================================}
procedure Mic2;
 var a,b: dword;
 begin
  if (callmask and 2)=2 then
   begin
    Mic2value:=not(Mic2value);
    if Mic2value=true then
     begin
      for a:=0 to 8 do
       begin
        for b:=0 to 15 do screen2[Mic2Y+a,Mic2X+b]:=Button_on[(a shl 4)+b];
       end;
     end
    else
     begin
      for a:=0 to 8 do
       begin
        for b:=0 to 15 do screen2[Mic2Y+a,Mic2X+b]:=Button_off[(a shl 4)+b];
       end;
     end;
    MIXER.Set_Input_Control_Right(Mic2Value,CD2RValue,CD2LValue,
          Line2RValue,Line2LValue,false,false);
   end;
 end;
{======================================================}
procedure Line2L;
 var a,b: dword;
 begin
  if (callmask and 2)=2 then
   begin
    Line2Lvalue:=not(Line2Lvalue);
    if Line2Lvalue=true then
     begin
      for a:=0 to 8 do
       begin
        for b:=0 to 15 do screen2[Line2LY+a,Line2LX+b]:=Button_on[(a shl 4)+b];
       end;
     end
    else
     begin
      for a:=0 to 8 do
       begin
        for b:=0 to 15 do screen2[Line2LY+a,Line2LX+b]:=Button_off[(a shl 4)+b];
       end;
     end;
     MIXER.Set_Input_Control_Right(Mic2Value,CD2RValue,CD2LValue,
          Line2RValue,Line2LValue,false,false);
   end;
 end;
{======================================================}
procedure Line2R;
 var a,b: dword;
 begin
  if (callmask and 2)=2 then
   begin
    Line2rvalue:=not(Line2Rvalue);
    if Line2Rvalue=true then
     begin
      for a:=0 to 8 do
       begin
        for b:=0 to 15 do screen2[Line2RY+a,Line2RX+b]:=Button_on[(a shl 4)+b];
       end;
     end
    else
     begin
      for a:=0 to 8 do
       begin
        for b:=0 to 15 do screen2[Line2RY+a,Line2RX+b]:=Button_off[(a shl 4)+b];
       end;
     end;
     MIXER.Set_Input_Control_Right(Mic2Value,CD2RValue,CD2LValue,
          Line2RValue,Line2LValue,false,false);
   end;
 end;
{======================================================}
procedure CD2L;
 var a,b: dword;
 begin
  if (callmask and 2)=2 then
   begin
    CD2Lvalue:=not(CD2Lvalue);
    if CD2Lvalue=true then
     begin
      for a:=0 to 8 do
       begin
        for b:=0 to 15 do screen2[CD2LY+a,CD2LX+b]:=Button_on[(a shl 4)+b];
       end;
     end
    else
     begin
      for a:=0 to 8 do
       begin
        for b:=0 to 15 do screen2[CD2LY+a,CD2LX+b]:=Button_off[(a shl 4)+b];
       end;
     end;
     MIXER.Set_Input_Control_Right(Mic2Value,CD2RValue,CD2LValue,
          Line2RValue,Line2LValue,false,false);
   end;
 end;
{======================================================}
procedure CD2R;
 var a,b: dword;
 begin
  if (callmask and 2)=2 then
   begin
    CD2Rvalue:=not(CD2Rvalue);
    if CD2Rvalue=true then
     begin
      for a:=0 to 8 do
       begin
        for b:=0 to 15 do screen2[CD2RY+a,CD2RX+b]:=Button_on[(a shl 4)+b];
       end;
     end
    else
     begin
      for a:=0 to 8 do
       begin
        for b:=0 to 15 do screen2[CD2RY+a,CD2RX+b]:=Button_off[(a shl 4)+b];
       end;
     end;
    MIXER.Set_Input_Control_Right(Mic2Value,CD2RValue,CD2LValue,
         Line2RValue,Line2LValue,false,false);
   end;
 end;
{======================================================}
procedure RasmusRadiomus1;
 var a,b: dword;
 begin
  if (callmask and 2)=2 then
   begin
    DoRasmusRadiomus1:=not(DoRasmusRadiomus1);
    if DoRasmusRadiomus1=true then
     begin
      for a:=0 to 8 do
       begin
        for b:=0 to 15 do screen2[Rasmus1Y+a,Rasmus1X+b]:=Button_on[(a shl 4)+b];
       end;
     end
    else
     begin
      for a:=0 to 8 do
       begin
        for b:=0 to 15 do screen2[Rasmus1Y+a,Rasmus1X+b]:=Button_off[(a shl 4)+b];
       end;
     end;
   end;
 end;
{======================================================}
procedure RasmusRadiomus2;
 var a,b: dword;
 begin
  if (callmask and 2)=2 then
   begin
    DoRasmusRadiomus2:=not(DoRasmusRadiomus2);
    if DoRasmusRadiomus2=true then
     begin
      for a:=0 to 8 do
       begin
        for b:=0 to 15 do screen2[Rasmus2Y+a,Rasmus2X+b]:=Button_on[(a shl 4)+b];
       end;
     end
    else
     begin
      for a:=0 to 8 do
       begin
        for b:=0 to 15 do screen2[Rasmus2Y+a,Rasmus2X+b]:=Button_off[(a shl 4)+b];
       end;
     end;
   end;
 end;
{======================================================}
Procedure Cross;
 begin
  if (callmask and 2)=2 then
   begin
    DefineRange(CrossX,CrossX+63,CrossY,CrossY+10);
    Active:=1;
   end;
  if (callmask and 4)=4 then DefineRange(0,304,0,184);
  if ((buttonspressed>0) and (Active=1)) then
   begin
    RestoreMixerbackground2(LastCrossPosition,@Cross_bck);
    LastCrossPosition:=(320*CrossY)+MouseX-1;
    SaveMixerBackground2(LastCrossPosition,@Cross_bck);
    DrawMixer2(LastCrossPosition);
    CrossVolume:=(MouseX-CrossX)/31.5;
   end;
 end;
{======================================================}
Procedure Master;
 begin
  if (callmask and 2)=2 then
   begin
    DefineRange(MasterX,MasterX+63,MasterY,MasterY+10);
    Active:=2;
   end;
  if (callmask and 4)=4 then DefineRange(0,304,0,184);
  if ((buttonspressed>0) and (Active=2)) then
   begin
    RestoreMixerbackground2(LastMasterPosition,@Master_bck);
    LastMasterPosition:=(320*MasterY)+MouseX-1;
    SaveMixerBackground2(LastMasterPosition,@Master_bck);
    DrawMixer2(LastMasterPosition);
    MasterVolume:=(MouseX-MasterX)*(3.16227766017/63);  {-uendelig - 10dB}
   end;
 end;
{======================================================}
Procedure Vol1;
 begin
  if (callmask and 2)=2 then
   begin
    DefineRange(Vol1X,Vol1X+13,Vol1Y,Vol1Y+63);
    Active:=3;
   end;
  if (callmask and 4)=4 then DefineRange(0,304,0,184);
  if ((buttonspressed>0) and (Active=3)) then
   begin
    RestoreMixerbackground1(LastVol1Position,@Vol1_bck);
    LastVol1Position:=320*MouseY+Vol1X+2-640;
    SaveMixerBackground1(LastVol1Position,@Vol1_bck);
    DrawMixer1(LastVol1Position);
    Volume1:=((63+Vol1Y)-MouseY)*(3.16227766017/63);  {-uendelig - 10dB}
   end;
 end;
{======================================================}
Procedure Gain_1;
 begin
  if (callmask and 2)=2 then
   begin
    DefineRange(Gain1X,Gain1X+30,Gain1Y,Gain1Y+10);
    Active:=4;
   end;
  if (callmask and 4)=4 then DefineRange(0,304,0,184);
  if ((buttonspressed>0) and (Active=4)) then
   begin
    RestoreMixerbackground2(LastGain1Position,@Gain1_bck);
    LastGain1Position:=(320*Gain1Y)+MouseX-1;
    SaveMixerBackground2(Lastgain1Position,@Gain1_bck);
    DrawMixer2(LastGain1Position);
    Gain1:=DBtable [30-(MouseX-Gain1X)];
    ReCalcImpulse1:=True;
   end;
 end;
{======================================================}
Procedure Low1;
 begin
  if (callmask and 2)=2 then
   begin
    DefineRange(Low1X,Low1X+13,Low1Y,Low1Y+30);
    Active:=5;
   end;
  if (callmask and 4)=4 then DefineRange(0,304,0,184);
  if ((buttonspressed>0) and (active=5)) then
   begin
    RestoreMixerbackground1(LastLow1Position,@Low1_bck);
    LastLow1Position:=320*MouseY+Low1X+2-640;
    SaveMixerBackground1(LastLow1Position,@Low1_bck);
    DrawMixer1(LastLow1Position);
    A1Lowpass:=DBtable [MouseY-Low1Y];
    ReCalcImpulse1:=True;
   end;
 end;
{======================================================}
Procedure Mid1;
 begin
  if (callmask and 2)=2 then
   begin
    DefineRange(Mid1X,Mid1X+13,Mid1Y,Mid1Y+30);
    Active:=6;
   end;
  if (callmask and 4)=4 then DefineRange(0,304,0,184);
  if ((buttonspressed>0) and (active=6)) then
   begin
    RestoreMixerbackground1(LastMid1Position,@Mid1_bck);
    LastMid1Position:=320*MouseY+Mid1X+2-640;
    SaveMixerBackground1(LastMid1Position,@Mid1_bck);
    DrawMixer1(LastMid1Position);
    A1Bandpass:=DBtable [MouseY-Mid1Y];
    ReCalcImpulse1:=True;
   end;
 end;
{======================================================}
Procedure High1;
 begin
  if (callmask and 2)=2 then
   begin
    DefineRange(High1X,High1X+13,High1Y,High1Y+30);
    Active:=7;
   end;
  if (callmask and 4)=4 then DefineRange(0,304,0,184);
  if ((buttonspressed>0) and (active=7)) then
   begin
    RestoreMixerbackground1(LastHigh1Position,@High1_bck);
    LastHigh1Position:=320*MouseY+High1X+2-640;
    SaveMixerBackground1(LastHigh1Position,@High1_bck);
    DrawMixer1(LastHigh1Position);
    A1Highpass:=DBtable [MouseY-High1Y];
    ReCalcImpulse1:=True;
   end;
 end;
{======================================================}
Procedure Thres1;
 begin
  if (callmask and 2)=2 then
   begin
    DefineRange(Thres1X,Thres1X+13,Thres1Y,Thres1Y+30);
    Active:=8;
   end;
  if (callmask and 4)=4 then DefineRange(0,304,0,184);
  if ((buttonspressed>0) and (active=8)) then
   begin
    RestoreMixerbackground1(LastThres1Position,@Thres1_bck);
    LastThres1Position:=320*MouseY+Thres1X+2-640;
    SaveMixerBackground1(LastThres1Position,@Thres1_bck);
    DrawMixer1(LastThres1Position);
    Gate1ThresHold:={6142}1536*(30-(MouseY-Thres1Y));   {15dB*32768/30}
   end;
 end;
{======================================================}
Procedure Hys1;
 begin
  if (callmask and 2)=2 then
   begin
    DefineRange(Hys1X,Hys1X+13,Hys1Y,Hys1Y+30);
    Active:=9;
   end;
  if (callmask and 4)=4 then DefineRange(0,304,0,184);
  if ((buttonspressed>0) and (active=9)) then
   begin
    RestoreMixerbackground1(LastHys1Position,@Hys1_bck);
    LastHys1Position:=320*MouseY+Hys1X+2-640;
    SaveMixerBackground1(LastHys1Position,@Hys1_bck);
    DrawMixer1(LastHys1Position);
    Gate1Hysterisis:={1092}273*(30-(MouseY-Hys1Y)); {32767/30}
   end;
 end;
{======================================================}
Procedure Hold1;
 begin
  if (callmask and 2)=2 then
   begin
    DefineRange(Hold1X,Hold1X+13,Hold1Y,Hold1Y+30);
    Active:=10;
   end;
  if (callmask and 4)=4 then DefineRange(0,304,0,184);
  if ((buttonspressed>0) and (active=10)) then
   begin
    RestoreMixerbackground1(LastHold1Position,@Hold1_bck);
    LastHold1Position:=320*MouseY+Hold1X+2-640;
    SaveMixerBackground1(LastHold1Position,@Hold1_bck);
    DrawMixer1(LastHold1Position);
    Gate1HoldTime:=2866*((30+Hold1Y)-MouseY)+2206; {(88200-2206)/30}
   end;
 end;
{======================================================}
Procedure Rel1;
 begin
  if (callmask and 2)=2 then
   begin
    DefineRange(Rel1X,Rel1X+13,Rel1Y,Rel1Y+30);
    Active:=11;
   end;
  if (callmask and 4)=4 then DefineRange(0,304,0,184);
  if ((buttonspressed>0) and (active=11)) then
   begin
    RestoreMixerbackground1(LastRel1Position,@Rel1_bck);
    LastRel1Position:=320*MouseY+Rel1X+2-640;
    SaveMixerBackground1(LastRel1Position,@Rel1_bck);
    DrawMixer1(LastRel1Position);
    If MouseY-Rel1Y<30 then
     Gate1ReleaseSpeed:=15/(44100*((30+Rel1Y)-mouseY))
    else
     Gate1ReleaseSpeed:=1;
   end;
 end;
{======================================================}
Procedure Atck1;
 begin
  if (callmask and 2)=2 then
   begin
    DefineRange(Atck1X,Atck1X+13,Atck1Y,Atck1Y+30);
    Active:=12;
   end;
  if (callmask and 4)=4 then DefineRange(0,304,0,184);
  if ((buttonspressed>0) and (active=12)) then
   begin
    RestoreMixerbackground1(LastAtck1Position,@Atck1_bck);
    LastAtck1Position:=320*MouseY+Atck1X+2-640;
    SaveMixerBackground1(LastAtck1Position,@Atck1_bck);
    DrawMixer1(LastAtck1Position);
    If MouseY-Atck1Y<30 then
     Gate1AttackSpeed:=15/(44100*((30+Atck1Y)-mouseY))
    else
     Gate1AttackSpeed:=1;
   end;
 end;
{======================================================}
Procedure Vol2;
 begin
  if (callmask and 2)=2 then
   begin
    DefineRange(Vol2X,Vol2X+13,Vol2Y,Vol2Y+63);
    Active:=13;
   end;
  if (callmask and 4)=4 then DefineRange(0,304,0,184);
  if ((buttonspressed>0) and (active=13)) then
   begin
    RestoreMixerbackground1(LastVol2Position,@Vol2_bck);
    LastVol2Position:=320*MouseY+Vol2X+2-640;
    SaveMixerBackground1(LastVol2Position,@Vol2_bck);
    DrawMixer1(LastVol2Position);
    Volume2:=((63+Vol2Y)-MouseY)*(3.16227766017/63);  {-uendelig - 10dB}
   end;
 end;
{======================================================}
Procedure Gain_2;
 begin
  if (callmask and 2)=2 then
   begin
    DefineRange(Gain2X,Gain2X+30,Gain2Y,Gain2Y+10);
    Active:=14;
   end;
  if (callmask and 4)=4 then DefineRange(0,304,0,184);
  if ((buttonspressed>0) and (Active=14)) then
   begin
    RestoreMixerbackground2(LastGain2Position,@Gain2_bck);
    LastGain2Position:=(320*Gain2Y)+MouseX-1;
    SaveMixerBackground2(LastGain2Position,@Gain2_bck);
    DrawMixer2(LastGain2Position);
    Gain2:=DBtable [30-(MouseX-Gain2X)];
    ReCalcImpulse2:=True;
   end;
 end;
{======================================================}
Procedure Low2;
 begin
  if (callmask and 2)=2 then
   begin
    DefineRange(Low2X,Low2X+13,Low2Y,Low2Y+30);
    active:=15;
   end;
  if (callmask and 4)=4 then DefineRange(0,304,0,184);
  if ((buttonspressed>0) and (active=15)) then
   begin
    RestoreMixerbackground1(LastLow2Position,@Low2_bck);
    LastLow2Position:=320*MouseY+Low2X+2-640;
    SaveMixerBackground1(LastLow2Position,@Low2_bck);
    DrawMixer1(LastLow2Position);
    A2Lowpass:=DBtable [MouseY-Low2Y];
    ReCalcImpulse2:=True;
   end;
 end;
{======================================================}
Procedure Mid2;
 begin
  if (callmask and 2)=2 then
   begin
    DefineRange(Mid2X,Mid2X+13,Mid2Y,Mid2Y+30);
    Active:=16;
   end;
  if (callmask and 4)=4 then DefineRange(0,304,0,184);
  if ((buttonspressed>0) and (active=16)) then
   begin
    RestoreMixerbackground1(LastMid2Position,@Mid2_bck);
    LastMid2Position:=320*MouseY+Mid2X+2-640;
    SaveMixerBackground1(LastMid2Position,@Mid2_bck);
    DrawMixer1(LastMid2Position);
    A2Bandpass:=DBtable [MouseY-Mid2Y];
    ReCalcImpulse2:=True;
   end;
 end;
{======================================================}
Procedure High2;
 begin
  if (callmask and 2)=2 then
   begin
    DefineRange(High2X,High2X+13,High2Y,High2Y+30);
    Active:=17;
   end;
  if (callmask and 4)=4 then DefineRange(0,304,0,184);
  if ((buttonspressed>0) and (Active=17)) then
   begin
    RestoreMixerbackground1(LastHigh2Position,@High2_bck);
    LastHigh2Position:=320*MouseY+High2X+2-640;
    SaveMixerBackground1(LastHigh2Position,@High2_bck);
    DrawMixer1(LastHigh2Position);
    A2highpass:=DBtable [MouseY-High2Y];
    ReCalcImpulse2:=True;
   end;
 end;
{======================================================}
Procedure Thres2;
 begin
  if (callmask and 2)=2 then
   begin
    DefineRange(Thres2X,Thres2X+13,Thres2Y,Thres2Y+30);
    Active:=18;
   end;
  if (callmask and 4)=4 then DefineRange(0,304,0,184);
  if ((buttonspressed>0) and (active=18)) then
   begin
    RestoreMixerbackground1(LastThres2Position,@Thres2_bck);
    LastThres2Position:=320*MouseY+Thres2X+2-640;
    SaveMixerBackground1(LastThres2Position,@Thres2_bck);
    DrawMixer1(LastThres2Position);
    Gate2ThresHold:={6142}1536*(30-(MouseY-Thres2Y));   {15dB*32768/30}
   end;
 end;
{======================================================}
Procedure Hys2;
 begin
  if (callmask and 2)=2 then
   begin
    DefineRange(Hys2X,Hys2X+13,Hys2Y,Hys2Y+30);
    Active:=19;
   end;
  if (callmask and 4)=4 then DefineRange(0,304,0,184);
  if ((buttonspressed>0) and (active=19)) then
   begin
    RestoreMixerbackground1(LastHys2Position,@Hys2_bck);
    LastHys2Position:=320*MouseY+Hys2X+2-640;
    SaveMixerBackground1(LastHys2Position,@Hys2_bck);
    DrawMixer1(LastHys2Position);
    Gate2Hysterisis:={1092}273*(30-(MouseY-Hys2Y)); {32767/30}
   end;
 end;
{======================================================}
Procedure Hold2;
 begin
  if (callmask and 2)=2 then
   begin
    DefineRange(Hold2X,Hold2X+13,Hold2Y,Hold2Y+30);
    Active:=20;
   end;
  if (callmask and 4)=4 then DefineRange(0,304,0,184);
  if ((buttonspressed>0) and (active=20)) then
   begin
    RestoreMixerbackground1(LastHold2Position,@Hold2_bck);
    LastHold2Position:=320*MouseY+Hold2X+2-640;
    SaveMixerBackground1(LastHold2Position,@Hold2_bck);
    DrawMixer1(LastHold2Position);
    Gate2HoldTime:=2866*((30+Hold2Y)-MouseY)+2206; {(88200-2206)/30}
   end;
 end;
{======================================================}
Procedure Rel2;
 begin
  if (callmask and 2)=2 then
   begin
    DefineRange(Rel2X,Rel2X+13,Rel2Y,Rel2Y+30);
    Active:=21;
   end;
  if (callmask and 4)=4 then DefineRange(0,304,0,184);
  if ((buttonspressed>0) and (active=21)) then
   begin
    RestoreMixerbackground1(LastRel2Position,@Rel2_bck);
    LastRel2Position:=320*MouseY+Rel2X+2-640;
    SaveMixerBackground1(LastRel2Position,@Rel2_bck);
    DrawMixer1(LastRel2Position);
    If MouseY-Rel2Y<30 then
     Gate2ReleaseSpeed:=15/(44100*((30+Rel2Y)-mouseY))
    else
     Gate2ReleaseSpeed:=1;
   end;
 end;
{======================================================}
Procedure Atck2;
 begin
  if (callmask and 2)=2 then
   begin
    DefineRange(Atck2X,Atck2X+13,Atck2Y,Atck2Y+30);
    Active:=22;
   end;
  if (callmask and 4)=4 then DefineRange(0,304,0,184);
  if ((buttonspressed>0) and (active=22)) then
   begin
    RestoreMixerbackground1(LastAtck2Position,@Atck2_bck);
    LastAtck2Position:=320*MouseY+Atck2X+2-640;
    SaveMixerBackground1(LastAtck2Position,@Atck2_bck);
    DrawMixer1(LastAtck2Position);
    If MouseY-Atck2Y<30 then
     Gate2AttackSpeed:=15/(44100*((30+Atck2Y)-mouseY))
    else
     Gate2AttackSpeed:=1;
   end;
 end;
{======================================================}
Procedure saveMousebackground(startpos: dword);
 var n1,n2,c1,c2: dword;
     s:^array[0..63] of dword;
 begin
  dword(s):=$A0000+startpos;
  n1:=0;
  n2:=0;

  repeat
   for c1:=0 to 3 do background[n1+c1]:=s^[n2+c1];
   n1:=n1+4;
   n2:=n2+80;
  until n1=64;
 end;
{======================================================}
Procedure restoreMousebackground(startpos: dword);
 var n1,n2,c1,c2: dword;
     s:^array[0..63] of dword;
 begin
  dword(s):=$A0000+startpos;
  n1:=0;
  n2:=0;

  repeat
   for c1:=0 to 3 do s^[n1+c1]:=background[n2+c1];
   n1:=n1+80;
   n2:=n2+4;
  until n2=64;
 end;
{======================================================}
procedure DrawMouse(startpos: dword);
 var n1,n2,c1,c2: dword;
     s:^array[0..63] of dword;
 begin
  {disable maskable interrupts}
  asm
   cli
  end;
  dword(s):=$A0000+startpos;
  n1:=0;
  n2:=0;
  repeat
   for c1:=0 to 3 do s^[n2+c1]:=s^[n2+c1] and MouseANDmask[n1+c1];
   n1:=n1+4;
   n2:=n2+80;
  until n1=64;
  n1:=0;
  n2:=0;
  repeat
   for c1:=0 to 3 do s^[n2+c1]:=s^[n2+c1] or MouseORmask[n1+c1];
   n1:=n1+4;
   n2:=n2+80;
  until n1=64;
  {enable interrupts}
  asm
   sti
  end;
 end;
{======================================================}
Procedure MouseHandler(Mask, Buttons, X, Y, MovX, MovY: System.Word);
 var a,b: word;
 begin
  asm
   mov eax,03h
   int 33h
   shr ecx, 1
   and edx,0FFFFh
   and ecx,0FFFFh
   mov [MouseY],edx
   mov [MouseX],ecx
  end;
  buttonspressed:=byte(buttons);
  Callmask:=byte(Mask);
  RestoreMousebackground(LastMousePosition);

  if (callmask and 4)=4 then Active:=0;

  Callstructure[MouseY,MouseX]^;

  LastMousePosition:=MouseY*320+MouseX;
  saveMousebackground(LastMousePosition);
  DrawMouse(LastMousePosition);
 end;
{======================================================}
procedure UpdateVUs(VUpos1,VUpos2: byte);
 const startY=105;
       startX=152;
       startpos=starty*320+startX-1;
       darkgreen=2;
       lightgreen=3;
       barlength=5;
       light: array[1..31] of dword =($03030303,
       $03030303,$03030303,$03030303,$03030303,$03030303,$03030303,
       $03030303,$03030303,$03030303,$03030303,$03030303,$03030303,
       $03030303,$03030303,$03030303,$03030303,$05050505,$05050505,
       $05050505,$05050505,$05050505,$05050505,$05050505,$05050505,
       $05050505,$07070707,$07070707,$07070707,$07070707,$07070707);
       Dark:  array[1..31] of dword =($02020202,
       $02020202,$02020202,$02020202,$02020202,$02020202,$02020202,
       $02020202,$02020202,$02020202,$02020202,$02020202,$02020202,
       $02020202,$02020202,$02020202,$02020202,$04040404,$04040404,
       $04040404,$04040404,$04040404,$04040404,$04040404,$04040404,
       $04040404,$06060606,$06060606,$06060606,$06060606,$06060606);
 var a: dword;
     d: ^dword;
 begin
  VUpos1:=VUpos1 shr 3;
  VUpos2:=VUpos2 shr 3;

  d:=@screen1[startpos];
  for a:=1 to VUpos1 do
   begin
    d^:=light[a];
    dword(d):=dword(d)-640;
   end;

  if VUpos1<31 then
   begin
    for a:=(VUpos1+1) to 31 do
     begin
      d^:=dark[a];
      dword(d):=dword(d)-640;
     end;
   end;

  d:=@screen1[startpos+12];
  for a:=1 to VUpos2 do
   begin
    d^:=light[a];
    dword(d):=dword(d)-640;
   end;

  if VUpos2<31 then
   begin
    for a:=(VUpos2+1) to 31 do
     begin
      d^:=dark[a];
      dword(d):=dword(d)-640;
     end;
   end;
  {if mousecursor above VUs then redraw mousecursor}
  if MouseY in [30..105] then
   if MouseX in [140..170] then DrawMouse(LastMousePosition);
 end;
{======================================================}
Procedure UpdateClippedLight(Clipped: boolean);
 var n1,n2,c1,c2: dword;
     s:^array[0..63] of dword;
 begin
  dword(s):=$A0000+(ClipY*320+ClipX);
  if clipped then
   begin
    setpal(0,40,0,0);
    n1:=0;
    n2:=0;
    repeat
     for c1:=0 to 3 do s^[n2+c1]:=Clip_on[n1+c1];
     n1:=n1+4;
     n2:=n2+80;
    until n1=64;
   end
  else
   begin
    setpal(0,0,0,0);
    n1:=0;
    n2:=0;
    repeat
     for c1:=0 to 3 do s^[n2+c1]:=Clip_off[n1+c1];
     n1:=n1+4;
     n2:=n2+80;
    until n1=64;
   end;
  {if mousecursor above indicator then redraw mousecursor}
  if MouseY in [107..138] then
  if MouseX in [140..170] then DrawMouse(LastMousePosition);
 end;
{======================================================}
Procedure Init;
 var a,b: longint;
 begin
  {setup callstructure}
  for a:=0 to 199 do for b:=0 to 319 do Callstructure[a,b]:=@foo;

  for a:=PowerY to (PowerY+8) do for b:=(PowerX) to (PowerX+13) do Callstructure[a,b]:=@Power;
  for a:=CrossY to (CrossY+10) do for b:=CrossX to (CrossX+63) do callstructure[a,b]:=@Cross;
  for a:=MasterY to (MasterY+10) do for b:=MasterX to (MasterX+63) do callstructure[a,b]:=@Master;

  for a:=Mic1Y to (Mic1Y+6) do for b:=(Mic1X) to (Mic1X+13) do Callstructure[a,b]:=@Mic1;
  for a:=Line1LY to (Line1LY+6) do for b:=(Line1LX) to (Line1LX+13) do Callstructure[a,b]:=@Line1L;
  for a:=Line1RY to (Line1RY+6) do for b:=(Line1RX) to (Line1RX+13) do Callstructure[a,b]:=@Line1R;
  for a:=CD1LY to (CD1LY+6) do for b:=(CD1LX) to (CD1LX+13) do Callstructure[a,b]:=@CD1L;
  for a:=CD1RY to (CD1RY+6) do for b:=(CD1RX) to (CD1RX+13) do Callstructure[a,b]:=@CD1R;
  for a:=Rasmus1Y to (Rasmus1Y+6) do for b:=(Rasmus1X) to (Rasmus1X+13) do Callstructure[a,b]:=@RasmusRadiomus1;

  for a:=Vol1Y to (Vol1Y+63) do for b:=Vol1X to (Vol1X+13) do callstructure[a,b]:=@Vol1;
  for a:=Gain1Y to (Gain1Y+10) do for b:=Gain1X to (Gain1X+30) do callstructure[a,b]:=@Gain_1;
  for a:=Low1Y to (Low1Y+30) do for b:=Low1X to (Low1X+13) do callstructure[a,b]:=@Low1;
  for a:=Mid1Y to (Mid1Y+30) do for b:=Mid1X to (Mid1X+13) do callstructure[a,b]:=@Mid1;
  for a:=High1Y to (High1Y+30) do for b:=High1X to (High1X+13) do callstructure[a,b]:=@High1;
  for a:=Thres1Y to (Thres1Y+30) do for b:=Thres1X to (Thres1X+13) do callstructure[a,b]:=@Thres1;
  for a:=Hys1Y to (Hys1Y+30) do for b:=Hys1X to (Hys1X+13) do callstructure[a,b]:=@Hys1;
  for a:=Hold1Y to (Hold1Y+30) do for b:=Hold1X to (Hold1X+13) do callstructure[a,b]:=@Hold1;
  for a:=Rel1Y to (Rel1Y+30) do for b:=Rel1X to (Rel1X+13) do callstructure[a,b]:=@Rel1;
  for a:=Atck1Y to (Atck1Y+30) do for b:=Atck1X to (Atck1X+13) do callstructure[a,b]:=@Atck1;

  for a:=Mic2Y to (Mic2Y+6) do for b:=(Mic2X) to (Mic2X+13) do Callstructure[a,b]:=@Mic2;
  for a:=Line2LY to (Line2LY+6) do for b:=(Line2LX) to (Line2LX+13) do Callstructure[a,b]:=@Line2L;
  for a:=Line2RY to (Line2RY+6) do for b:=(Line2RX) to (Line2RX+13) do Callstructure[a,b]:=@Line2R;
  for a:=CD2LY to (CD2LY+6) do for b:=(CD2LX) to (CD2LX+13) do Callstructure[a,b]:=@CD2L;
  for a:=CD2RY to (CD2RY+6) do for b:=(CD2RX) to (CD2RX+13) do Callstructure[a,b]:=@CD2R;
  for a:=Rasmus2Y to (Rasmus2Y+6) do for b:=(Rasmus2X) to (Rasmus2X+13) do Callstructure[a,b]:=@RasmusRadiomus2;

  for a:=Vol2Y to (Vol2Y+63) do for b:=Vol2X to (Vol2X+13) do callstructure[a,b]:=@Vol2;
  for a:=Gain2Y to (Gain2Y+10) do for b:=Gain2X to (Gain2X+30) do callstructure[a,b]:=@Gain_2;
  for a:=Low2Y to (Low2Y+30) do for b:=Low2X to (Low2X+13) do callstructure[a,b]:=@Low2;
  for a:=Mid2Y to (Mid2Y+30) do for b:=Mid2X to (Mid2X+13) do callstructure[a,b]:=@Mid2;
  for a:=High2Y to (High2Y+30) do for b:=High2X to (High2X+13) do callstructure[a,b]:=@High2;
  for a:=Thres2Y to (Thres2Y+30) do for b:=Thres2X to (Thres2X+13) do callstructure[a,b]:=@Thres2;
  for a:=Hys2Y to (Hys2Y+30) do for b:=Hys2X to (Hys2X+13) do callstructure[a,b]:=@Hys2;
  for a:=Hold2Y to (Hold2Y+30) do for b:=Hold2X to (Hold2X+13) do callstructure[a,b]:=@Hold2;
  for a:=Rel2Y to (Rel2Y+30) do for b:=Rel2X to (Rel2X+13) do callstructure[a,b]:=@Rel2;
  for a:=Atck2Y to (Atck2Y+30) do for b:=Atck2X to (Atck2X+13) do callstructure[a,b]:=@Atck2;

  InitMouse;
  if ButtonCount=0 then
   begin
    writeln('Error! Mousedriver not detected!');
    writeln('Halting..');
    halt;
   end;
  Setmode(VGA);
  Readgraphics(PictureFileName);
  Hidemouse;
  SetMouseHandler(31,MouseHandler);

  DefineRange(0,304,0,184);
  {init vars}
  Buttonspressed:=1;
  Callmask:=2;
  LastMousePosition:=0;
  LastCrossPosition:=CrossY*320+CrossX+30;
  LastMasterPosition:=MasterY*320+MasterX+17;

  LastVol1Position:=(Vol1Y+42)*320+Vol1X+2;
  LastGain1Position:=Gain1Y*320+Gain1X+14;
  LastLow1Position:=(Low1Y+12)*320+Low1X+2;
  LastMid1Position:=(Mid1Y+12)*320+Mid1X+2;
  LastHigh1Position:=(High1Y+12)*320+High1X+2;
  LastThres1Position:=(Thres1Y+28)*320+Thres1X+2;
  LastHys1Position:=(Hys1Y+28)*320+Hys1X+2;
  LastHold1Position:=(Hold1Y+28)*320+Hold1X+2;
  LastRel1Position:=(Rel1Y+28)*320+Rel1X+2;
  LastAtck1Position:=(Atck1Y+28)*320+Atck1X+2;

  LastVol2Position:=(Vol2Y+42)*320+Vol2X+2;
  LastGain2Position:=Gain2Y*320+Gain2X+14;
  LastLow2Position:=(Low2Y+12)*320+Low2X+2;
  LastMid2Position:=(Mid2Y+12)*320+Mid2X+2;
  LastHigh2Position:=(High2Y+12)*320+High2X+2;
  LastThres2Position:=(Thres2Y+28)*320+Thres2X+2;
  LastHys2Position:=(Hys2Y+28)*320+Hys2X+2;
  LastHold2Position:=(Hold2Y+28)*320+Hold2X+2;
  LastRel2Position:=(Rel2Y+28)*320+Rel2X+2;
  LastAtck2Position:=(Atck2Y+28)*320+Atck2X+2;

  SaveMousebackground(LastMousePosition);
  SaveMixerbackground2(LastCrossPosition,@Cross_bck);
  SaveMixerbackground2(LastMasterPosition,@Master_bck);

  SaveMixerbackground1(LastVol1Position,@Vol1_bck);
  SaveMixerbackground2(LastGain1Position,@Gain1_bck);
  SaveMixerbackground1(LastLow1Position,@Low1_bck);
  SaveMixerbackground1(LastMid1Position,@Mid1_bck);
  SaveMixerbackground1(LastHigh1Position,@High1_bck);
  SaveMixerbackground1(LastThres1Position,@Thres1_bck);
  SaveMixerbackground1(LastHys1Position,@Hys1_bck);
  SaveMixerbackground1(LastHold1Position,@Hold1_bck);
  SaveMixerbackground1(LastRel1Position,@Rel1_bck);
  SaveMixerbackground1(LastAtck1Position,@Atck1_bck);

  SaveMixerbackground1(LastVol2Position,@Vol2_bck);
  SaveMixerbackground2(LastGain2Position,@Gain2_bck);
  SaveMixerbackground1(LastLow2Position,@Low2_bck);
  SaveMixerbackground1(LastMid2Position,@Mid2_bck);
  SaveMixerbackground1(LastHigh2Position,@High2_bck);
  SaveMixerbackground1(LastThres2Position,@Thres2_bck);
  SaveMixerbackground1(LastHys2Position,@Hys2_bck);
  SaveMixerbackground1(LastHold2Position,@Hold2_bck);
  SaveMixerbackground1(LastRel2Position,@Rel2_bck);
  SaveMixerbackground1(LastAtck2Position,@Atck2_bck);

  DrawMouse(LastMousePosition);
  DrawMixer2(LastCrossPosition);
  DrawMixer2(LastMasterPosition);

  DrawMixer1(LastVol1Position);
  DrawMixer2(LastGain1Position);
  DrawMixer1(LastLow1Position);
  DrawMixer1(LastMid1Position);
  DrawMixer1(LastHigh1Position);
  DrawMixer1(LastThres1Position);
  DrawMixer1(LastHys1Position);
  DrawMixer1(LastHold1Position);
  DrawMixer1(LastRel1Position);
  DrawMixer1(LastAtck1Position);

  DrawMixer1(LastVol2Position);
  DrawMixer2(LastGain2Position);
  DrawMixer1(LastLow2Position);
  DrawMixer1(LastMid2Position);
  DrawMixer1(LastHigh2Position);
  DrawMixer1(LastThres2Position);
  DrawMixer1(LastHys2Position);
  DrawMixer1(LastHold2Position);
  DrawMixer1(LastRel2Position);
  DrawMixer1(LastAtck2Position);

  Mic1value:=True;
  Line1Lvalue:=True; Line1Rvalue:=True;
  CD1Lvalue:=True; CD1Rvalue:=True;
  DoRasmusRadiomus1:=True;

  Mic2value:=True;
  Line2Lvalue:=True; Line2Rvalue:=True;
  CD2Lvalue:=True; CD2Rvalue:=True;
  DoRasmusRadiomus2:=True;

  MouseX:=0; MouseY:=0;
  Active:=0;

  Mic1;
  Line1L; Line1R;
  CD1L;   CD1R;
  RasmusRadiomus1;  
 
  Mic2;
  Line2L; Line2R;
  CD2L;   CD2R;
  RasmusRadiomus2; 
 end;
{======================================================}
Procedure DeInit;
 begin
  ClearMouseHandler;
  DoneMouse;
  setmode(text);
 end;
{======================================================}

begin
end.